<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OKurstestergebnisAuskunft StructType
 * @subpackage Structs
 */
class OKurstestergebnisAuskunft extends AbstractStructBase
{
    /**
     * The traeger
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\KurstraegerAuskunft
     */
    public $traeger;
    /**
     * The testdatum
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $testdatum;
    /**
     * The bestanden
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $bestanden;
    /**
     * The erreichtePunktzahl
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $erreichtePunktzahl;
    /**
     * Constructor method for OKurstestergebnisAuskunft
     * @uses OKurstestergebnisAuskunft::setTraeger()
     * @uses OKurstestergebnisAuskunft::setTestdatum()
     * @uses OKurstestergebnisAuskunft::setBestanden()
     * @uses OKurstestergebnisAuskunft::setErreichtePunktzahl()
     * @param \StructType\KurstraegerAuskunft $traeger
     * @param string $testdatum
     * @param bool $bestanden
     * @param string $erreichtePunktzahl
     */
    public function __construct(\StructType\KurstraegerAuskunft $traeger = null, $testdatum = null, $bestanden = null, $erreichtePunktzahl = null)
    {
        $this
            ->setTraeger($traeger)
            ->setTestdatum($testdatum)
            ->setBestanden($bestanden)
            ->setErreichtePunktzahl($erreichtePunktzahl);
    }
    /**
     * Get traeger value
     * @return \StructType\KurstraegerAuskunft
     */
    public function getTraeger()
    {
        return $this->traeger;
    }
    /**
     * Set traeger value
     * @param \StructType\KurstraegerAuskunft $traeger
     * @return \StructType\OKurstestergebnisAuskunft
     */
    public function setTraeger(\StructType\KurstraegerAuskunft $traeger = null)
    {
        $this->traeger = $traeger;
        return $this;
    }
    /**
     * Get testdatum value
     * @return string
     */
    public function getTestdatum()
    {
        return $this->testdatum;
    }
    /**
     * Set testdatum value
     * @param string $testdatum
     * @return \StructType\OKurstestergebnisAuskunft
     */
    public function setTestdatum($testdatum = null)
    {
        // validation for constraint: string
        if (!is_null($testdatum) && !is_string($testdatum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($testdatum, true), gettype($testdatum)), __LINE__);
        }
        $this->testdatum = $testdatum;
        return $this;
    }
    /**
     * Get bestanden value
     * @return bool
     */
    public function getBestanden()
    {
        return $this->bestanden;
    }
    /**
     * Set bestanden value
     * @param bool $bestanden
     * @return \StructType\OKurstestergebnisAuskunft
     */
    public function setBestanden($bestanden = null)
    {
        // validation for constraint: boolean
        if (!is_null($bestanden) && !is_bool($bestanden)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($bestanden, true), gettype($bestanden)), __LINE__);
        }
        $this->bestanden = $bestanden;
        return $this;
    }
    /**
     * Get erreichtePunktzahl value
     * @return string|null
     */
    public function getErreichtePunktzahl()
    {
        return $this->erreichtePunktzahl;
    }
    /**
     * Set erreichtePunktzahl value
     * @param string $erreichtePunktzahl
     * @return \StructType\OKurstestergebnisAuskunft
     */
    public function setErreichtePunktzahl($erreichtePunktzahl = null)
    {
        // validation for constraint: string
        if (!is_null($erreichtePunktzahl) && !is_string($erreichtePunktzahl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($erreichtePunktzahl, true), gettype($erreichtePunktzahl)), __LINE__);
        }
        $this->erreichtePunktzahl = $erreichtePunktzahl;
        return $this;
    }
}
